;--------------------------------------------------------
; Config Menu Music Player A                            |
; by madsiur (themadsiur@gmail.com)                     |
; version 1.3.1                                         |
; Released on 03/11/2017                                |
;--------------------------------------------------------   

hirom       ;Do not touch
;header     ;uncomment if you have a header

table menu.tbl,rtl              ;Menu Table file
MUSICPLAYER_NUM_ROWS equ $000D  ;Music player number of rows

;------------------------------------
; Current field song preservation   |
;------------------------------------
org $C3011A             ;In invoke main menu
JSR SaveSong            ;Save current song ID
JMP $01BA               ;Enter menu loop

org $C31DCB             ;When pressing B to exit main menu
JSR RestoreSong         ;Set last field song as current song
STZ $26                 ;Fade out
RTS

;------------------------------------   
; Music menu option code (Config 1) |
;------------------------------------
org $C302D1         ;In menu actions table
dw InitMusic        ;Menu action #$7B (music player initialization)
dw LoopMusic        ;Menu action #$7C (sustain music player)

org $C34949
dw $3C35            ; "BGM" Position
db $81,$86,$8C,$00  ; "BGM"

org $C32354
dw ClickSoundOpt    ; Handle clicks on "Stereo" or "BGM"

org $C31C7D         ;In initialize Config menu
JSR DisableHDMA     ;Disable HDMA in case we come from music player

org $C33C85
LDA $C3             ; Check if we are on "BMG"
BNE isOnBgmB        ; Branch if so
LDA $1D4E           ; Game options
AND #$20            ; Stereo?
BEQ StereoOn        ; Branch if so
LDA #$28            ; Color: Gray
BRA DrawStereo      ; Draw "Stereo"
StereoOn:
LDA #$20            ; Color: User's
DrawStereo:
STA $29             ; Set palette
LDY #$4940          ; Text pointer
JSR $02F9           ; Draw "Stereo"
LDA #$20            ; Color: User's
JSR DrawBmg         ; Draw "BMG"
RTS

isOnBgmB:
LDA #$24            ; Color: Blue
DrawBmg:
STA $29             ; Set palette
LDY #$4949          ; Text pointer
JSR $02F9           ; Draw "BMG"
RTS

org $C33E1A
LDA $0B             ; Semi-auto keys
BIT #$01            ; Pushing right?
BNE IsOnBgm         ; Branch if so
STZ $C3             ; Clear temp value
BRA RedrawOpt       ; Redraw Options
IsOnBgm:
LDA #$01            ; Set temp value
STA $C3             ; Save it to keep position ("BMG" or "Stereo")
RedrawOpt:
JSR $0EA3           ; Sound: Cursor
JMP $3C85           ; Redraw Options

;------------------------------------
; Extra Functions                   |
;------------------------------------

org $C3F091         ;Free $C3 bank space used for rest of code. Could be moved inside $C3 bank...

ReturnToMenu:       ;When pressing B in music player (called from mplayercore.asm)
JSR $0EA9           ;Click sound
LDA #$0D            ;Config Initialization ID
STA $27             ;Queue Config init
STZ $26             ;Fade out
RTS

DisableHDMA:        ;Disable HDMA in Config 1 (in case of coming back from music player)
LDA #$40            ;Channel 5
TRB $43             ;Halt HDMA 5   
JSR $352F           ;Reset/Stop stuff
STZ $5F             ;Set former cursor row to 0 (later stored in current row)
STZ $C3             ; Init Stereo/BGM line position
RTS

ClickSoundOpt:      ; From $C32350
LDA $C3             ; Load Temp value for line position (left or right)
BEQ IsStereo        ; Branch if on Stereo option
JSR $0EB2           ; Sound: Click
LDA #$7B            ; Music player initialization action
STA $27             ; Queue music player initialization
STZ $26             ; Next: Fade-out
RTS

IsStereo:           ; From Tag ClickSoundOpt
LDA $1D4E           ; Game options
AND #$20            ; Stereo?
BEQ SetMono         ; Branch if so, we now change the option
TDC                 ; Volume: Stereo
JSR AjustVol        ; Adjust volume
LDA #$20            ; Mode: Stereo
TRB $1D4E           ; Set option
JSR $0EB2           ; Sound: Click
JMP $3C85           ; Redraw options

SetMono:            ; From Tag IsStereo
LDA #$FF            ; Volume: Mono
JSR AjustVol        ; Adjust volume
LDA #$20            ; Mono flag
TSB $1D4E           ; Set mono mode
JSR $0EB2           ; Sound: Click
JMP $3C85           ; Redraw options

AjustVol:           ; From Tag IsStereo, SetStereo
STA $001301         ; Set sound mode
LDA #$F3            ; SPC code: $0D61
STA $001300         ; Set SPC command
JSL $C50004         ; Update ports
RTS

;------------------------------------
; External code                     |
;------------------------------------
incsrc mplayercore.asm  ;Music player       (need to remain in bank $C3)
incsrc mplayerdata.asm  ;Music player data  (could be moved outside bank $C3)
incsrc soundresume.asm  ;SPC code changes   (bank $C5)








