;--------------------------------------------------------
; Config Menu Music Player B                            |
; by madsiur (themadsiur@gmail.com)                     |
; version 1.3.2                                         |
; Released on 03/17/2017                                |
;--------------------------------------------------------   

hirom       ;Do not touch
;header     ;uncomment if you have a header

table menu.tbl,rtl              ;Menu Table file
MUSICPLAYER_NUM_ROWS equ $000D  ;Music player number of rows

;------------------------------------
; Current field song preservation   |
;------------------------------------
org $C3011A             ;In invoke main menu
JSR SaveSong            ;Save current song ID
JMP $01BA               ;Enter menu loop

org $C31DCB             ;When pressing B to exit main menu
JSR RestoreSong         ;Set last field song as current song
STZ $26                 ;Fade out
RTS

;------------------------------------   
; Music menu option code (Config 1) |
;------------------------------------
org $C302D1         ;In menu actions table
dw InitMusic        ;Menu action #$7B (music player initialization)
dw LoopMusic        ;Menu action #$7C (sustain music player)
   
org $C322D0         ;In sustain Config menu
CMP #$09            ;Row 9 will now indicate if a down press trigger Config 2 screen

org $C3386B         ;In navigation data for Config 1
db $0A              ;We now have 10 rows instead of 9

org $C33A40         ;In scroll to Config 1
LDA #$09            ;New row we are landing on in Config 1 when coming from Config 2

org $C32347         ;In handle clicks on Config 2
JMP (ClickTable,X)  ;Use relocated table (to make room for an extra Config 1 click)

org $C3235C         ;In Config 1 clicks jump table
dw BgmOption        ;Add a pointer for a click on "Music"

org $C349A1         ;In positioned text table for Config page 1
                    ;Use relocated "Config" space to put two new text pointers
dw BgmString        ;"BMG" text pointer
dw PlayerString     ;"Music" text pointer

org $C33861         ;In handle D-Pad for Config 1
LDY #CursorTable    ;Use relocated table

org $C338CD         ;In draw Config menu
LDY #ConfigString   ;Load relocated text pointer

org $C33D3D         ;In handle Config changes with D-Pad
JMP (Config2Opt,X)  ;Handle Config 2 options
JMP (Config1Opt,X)  ;Handle Config 1 options

org $C3393B         ;In draw Config menu
JSR DrawNewStrings  ;Draw "BGM" and "Music" strings

org $C31C7D         ;In initialize Config menu
JSR DisableHDMA     ;Disable HDMA in case we come from music player

org $C3F091         ;Free $C3 bank space used for rest of code

;------------------------------------
; Relocated and expanded tables     |
;------------------------------------
ClickTable:         ;Table that handle clicks on Config 2
dw $2341            ;Mag.Order  (NOP)
dw $2341            ;Window     (NOP)
dw $2388            ;Color
dw $2388            ;R
dw $2388            ;G
dw $2388            ;B

CursorTable:        ;Cursor position table for Config 1
dw $2960            ;Bat.Mode
dw $3960            ;Bat.Speed
dw $4960            ;Msg.Speed  
dw $5960            ;Cmd.Set
dw $6960            ;Gauge
dw $7960            ;Sound
dw $8960            ;Cursor
dw $9960            ;Reequip
dw $A960            ;Controller
dw $B960            ;BMG (new entry)

Config1Opt:         ;Jump table for Config 1 options
dw $3D61            ;Bat.Mode
dw $3D7A            ;Bat.Speed
dw $3DAB            ;Msg.Speed
dw $3DE8            ;Cmd.Set
dw $3E01            ;Gauge
dw $3E1A            ;Sound
dw $3E4E            ;Cursor
dw $3E6D            ;Reequip
dw $3E86            ;Controller
dw BgmOption        ;BMG (new entry)

Config2Opt:         ;Jump table for Config 2 options
dw $3E9F            ;Mag.Order
dw $3ECD            ;Window
dw $3F01            ;Viewed color
dw $3F3C            ;R
dw $3F5B            ;G
dw $3F7A            ;B

;------------------------------------
; Relocated and new Strings         |
;------------------------------------
ConfigString:
dw $78F9            ;"Config" position
db $82,$A8,$A7,$9F  ;"Config"
db $A2,$A0,$00

BgmString:
dw $3E0F            ;"BGM" position
db $81,$86,$8C,$00  ;"BGM"

PlayerString:
dw $3E25            ;"Music" position
db $8C,$AE,$AC      ;"Music"
db $A2,$9C,$00          

;------------------------------------
; Hook ups and functions            |
;------------------------------------
DrawNewStrings:     ;Draw "BGM" and "Music"
JSR $41C3           ;Draw RGB info
LDA #$24            ;Palette 1
STA $29             ;Color: Blue
LDY #BgmString      ;Text pointer
JSR $02F9           ;Draw "BGM"
LDA #$20            ;Palette 
STA $29             ;Color: User's
LDY #PlayerString   ;Text pointer
JSR $02F9           ;Draw "Music Player"
RTS

BgmOption:          ;Music player option clicked (left, right or A)
LDA $0B             ;Semi-auto keys
BIT #$02            ;Pushing left? (cause menu crashing)
BNE exit            ;Branch if so
JSR $0EA3           ;Sound: Cursor
LDA #$7B            ;Music player initialization action
STA $27             ;Queue music player initialization
STZ $26             ;Next: Fade-out
exit:
RTS

ReturnToMenu:       ;When pressing B in music player (called from mplayercore.asm)
JSR $0EA9           ;Click sound
LDA #$0D            ;Config Initialization ID
STA $27             ;Queue Config init
STZ $26             ;Fade out
RTS

DisableHDMA:        ;Disable HDMA in Config 1 (in case of coming back from music player)
LDA #$40            ;Channel 5
TRB $43             ;Halt HDMA 5   
JSR $352F           ;Reset/Stop stuff
STZ $5F             ;Set former cursor row to 0 (later stored in current row)
RTS

;------------------------------------
; External code                     |
;------------------------------------
incsrc mplayercore.asm  ;Music player       (need to remain in bank $C3)
incsrc mplayerdata.asm  ;Music player data  (could be moved outside bank $C3)
incsrc soundresume.asm  ;SPC code changes   (bank $C5)









